/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package BluetoothJavaServer.src.edu.kufpg.bluetooth.server;

import Vue.FXMLVueController;
import app.App;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.bluetooth.DeviceClass;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.DiscoveryListener;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;

/**
 *
 * @author puiss
 */
public class BluetoothManager implements DiscoveryListener {
    
    private Object lock=new Object();
    private static ArrayList<RemoteDevice> devices;
    private final List<ServiceRecord> serviceRecords = new ArrayList<ServiceRecord>();
    private final List<BluetoothConnection> connections = new ArrayList<BluetoothConnection>();
    private BluetoothThread t;
    private FXMLVueController observer;
    
    public BluetoothThread getWorkingThread(){
        return t;
    }

    public BluetoothManager(FXMLVueController observer){
        this.devices = new ArrayList<RemoteDevice>();
        this.observer = observer;
    }
    
    @Override
    public void deviceDiscovered(RemoteDevice btDevice, DeviceClass arg1) {
        String name;
        try {
            name = btDevice.getFriendlyName(false);
        } catch (Exception e) {
            name = btDevice.getBluetoothAddress();
        }
        
        devices.add(btDevice);
        System.out.println("device found: " + name);
        
    }

    @Override
    public void inquiryCompleted(int arg0) {
        synchronized(lock){
            lock.notify();
        }
    }

   
    @Override
    public void serviceSearchCompleted(int arg0, int arg1) {
        synchronized (lock) {
            lock.notify();
        }
    }

    @Override
    public void servicesDiscovered(int transID, ServiceRecord[] servRecord) {
    	System.out.println("hey ! " + servRecord);
    	for(ServiceRecord s : servRecord) {
    		System.out.println("-------"+ s + "-------");
    	}
    	serviceRecords.addAll(Arrays.asList(servRecord));
    }
    
    
    public boolean launch(){   
        try{
            UUID serialPortUuid = new UUID(BluetoothServiceUuids.SERIAL_PORT.getHexValue());
            UUID[] desiredServiceUuids = new UUID[] { serialPortUuid };
            LocalDevice localDevice = LocalDevice.getLocalDevice();
            DiscoveryAgent agent = localDevice.getDiscoveryAgent();
            RemoteDevice[] devices = agent.retrieveDevices(DiscoveryAgent.PREKNOWN);
            for(RemoteDevice d : devices) {
            	if(d.getBluetoothAddress().equals("201611073171")) {
                    System.out.println("Thingz trouve");
                    synchronized(lock) {
                        int result = agent.searchServices(null, desiredServiceUuids, d, this);
                        if( DiscoveryListener.SERVICE_SEARCH_DEVICE_NOT_REACHABLE == result) {
                            System.out.println(" but it could not be reached");
                            continue;
        		}
        		lock.wait();
        				
        				
        		System.out.println("service records found");
        				
        		if(null != serviceRecords && serviceRecords.size() > 0) {
                            System.out.println("YA DES SERVICES");
                            for(ServiceRecord serviceRecord: serviceRecords) {
                                String connectionUrl = serviceRecord.getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false); // I have no idea what these args are
        			StreamConnection connection;
        			try {
                                    connection = (StreamConnection)Connector.open(connectionUrl);
                                    DataInputStream inputStream = new DataInputStream(connection.openDataInputStream());
                                    BluetoothConnection bluetoothConnection = new BluetoothConnection(d.getBluetoothAddress(), inputStream);
                                    bluetoothConnection.setOutputStream(new DataOutputStream(connection.openOutputStream()));
                                    connections.add(bluetoothConnection);
                                    System.out.println("Connected to " + d.getBluetoothAddress());
                                    return true;
        			} catch (IOException e) {
                                    System.out.println("Could not connect to " + d.getBluetoothAddress() + ": " + e.getMessage());
                                    e.printStackTrace();
                                    return false;
                                }
                            }
        		}
                    }
            	}
            }
    } catch(Exception e){
        e.printStackTrace();
        return false;
    }
      return false;   
    }
    
    /**
     *
     */
    public void startThread() throws Exception {
        try {
            if(connections.size() > 0) { // we are connected
            	System.out.println("start");
            	this.t = new BluetoothThread(connections.get(0), observer);
            	t.start();
            }
          } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
}
